/*
 * DC_Filter_SendOutput.java
 *
 * Created on August 20, 2001, 11:53 AM
 */
/**
 *
 * @author  sergek
 * @version 
 */

import dc.jfilters.*;

public class DC_Filter_SendOutput extends DC_Filter_Base_t {
    public DC_Filter_SendOutput() {
	super();
    }

    // user-defined interface methods
    public int start_work(initarg_t arg) {
        System.out.println(arg.getSbFilterName() + ": Starting Work");

	return DC_RTN_t.DC_RTN_OK;
    }
    
    public int process(arg_t arg) {
        DC_Buffer_t[] b = new DC_Buffer_t[5];
	
	b[0] = new DC_Buffer_t(10);	
	b[1] = new DC_Buffer_t(100);
	b[2] = new DC_Buffer_t(1000);
	b[3] = new DC_Buffer_t(10000);
	b[4] = new DC_Buffer_t(100000);

	try {
           for (int i = 0; i < b[0].getMax(); i++) {
              b[0].Append("A".getBytes(), 1);
           }

           for (int i = 0; i < b[1].getMax(); i++) {
              b[1].Append("B".getBytes(), 1);
           }

           for (int i = 0; i < b[2].getMax(); i++) {
              b[2].Append("C".getBytes(), 1);
           }

           for (int i = 0; i < b[3].getMax(); i++) {
              b[3].Append("D".getBytes(), 1);
           }

           for (int i = 0; i < b[4].getMax(); i++) {
              b[4].Append("E".getBytes(), 1);
           }
	
	   System.out.println("Created last buffer");
	} catch (Exception e) {
	   System.out.println(e.getMessage());
	}

	for (int i = 0; i < b.length; i++) {
	   long startTime = System.currentTimeMillis();
	   arg.getOuts(0).write_nocopy(b[i]);
	   long result = System.currentTimeMillis() - startTime;
	   System.out.println("Buffer " + i + " output in " + result);
	}

	arg.getOuts(0).close();
	return DC_RTN_t.DC_RTN_OK;
    }

    public int finish_work() {
        System.out.println("Finish Work");
   	
	return DC_RTN_t.DC_RTN_OK; 
   }
}
