// -*- c++ -*-
// ****************************************************************************
//  Name: dird-client.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 09/12/1999 : mdb - Created.
//  Desc: 
// ****************************************************************************

#if !defined(H_DC_DIRD_CLIENT)
#define H_DC_DIRD_CLIENT

#include "dird.h"
#include "lib/dc_memory.h"

//
//  Client access routines
//

int Dird_Ping(char *sbDirdHost=NULL, int wDirdPort=0);
/// buf contains the sprinted [section]\nname=value entries
int Dird_Add(MemoryBuf &buf,
	     char *sbDirdHost=NULL, int wDirdPort=0);
int Dird_Query(char *sbQuery, ConfigInfo &cfg,
	       char *sbDirdHost=NULL, int wDirdPort=0,
	       int nWait=0);
/// buf contains the section name only
int Dird_Remove(MemoryBuf &buf,
		char *sbDirdHost=NULL, int wDirdPort=0);
int Dird_Shutdown(char *sbDirdHost=NULL, int wDirdPort=0);

#endif /* H_DC_DIRD_CLIENT */
// ****************************************************************************
