package dc.jfilters;

public class arg_t {
    //SK: REMOVED FRIEND DECLARATION (NO FRIENDS IN JAVA)
    //friend class DC_RemoteProcessState;
    //friend class DC_FilterInstance_t;
    //friend class DC_RemoteFilterCopy;
    
    
    //SK: REPLACED INSTANCE VARIABLES WITH ACCESS FUNCTIONS
    //public int nins;
    //public DC_PipeInStream_t  ins;
    //public int nouts;
    //public DC_PipeOutStream_t outs;
    //public String sbFilterName;
    //public DC_Work_t pwork;
    public int getNins() {
        return _getNins();
    }

    //removed public void setNins(int newNins) (JAVA knows the size of arrays so this is unnecessary and just introduces errors)   

    public DC_PipeInStream_t[] getIns() {
        _getIns();
        
        return ins;
    }
    
    public DC_PipeInStream_t getIns(int index) throws ArrayIndexOutOfBoundsException {
        if (index < 0 || index > getNins()) {
            throw new ArrayIndexOutOfBoundsException("in arg_t.getIns(index) index must be at least 0 and less than " + getNins());
        }        
        _getIns(index);
        
        return ins[index];
    }
    
    public void setIns(DC_PipeInStream_t[] newIns) {
        if (newIns != null) {
            ins = new DC_PipeInStream_t[newIns.length];
            _setNins(newIns.length);
            for (int i = 0; i < newIns.length; i++) {
                ins[i] = newIns[i];
            }            
            _setIns(newIns);
        }
        else {
            ins = null;
        }
    }

    public void setIns(DC_PipeInStream_t newIns, int index) throws ArrayIndexOutOfBoundsException {
        if (ins == null) {
            ins = new DC_PipeInStream_t[index + 1];
        }
        else if (index < 0 || index > getNins()) {
            throw new ArrayIndexOutOfBoundsException("in arg_t.setIns(DC_PipeInStream_t, index) index must be at least 0 and less than " + getNins());
        }    
        
	ins[index] = newIns;
        _setIns(newIns, index);
    }
    
    public int getNouts() {
        return _getNouts();
    }
    
    //removed void setNouts(int newNouts) (JAVA knows the size of arrays so this is unnecessary and just introduces errors)          
    
     public DC_PipeOutStream_t[] getOuts() {
        _getOuts();
        
        return outs;
     }
    
    public DC_PipeOutStream_t getOuts(int index) throws ArrayIndexOutOfBoundsException {
        if (index < 0 || index > getNouts()) {
            throw new ArrayIndexOutOfBoundsException("in arg_t.getOuts(index) index must be at least 0 and less than " + getNouts());
        }        
        _getOuts(index);
        
        return outs[index];
    }
    
    public void setOuts(DC_PipeOutStream_t[] newOuts) {
        if (newOuts != null) {
            outs = new DC_PipeOutStream_t[newOuts.length];
            _setNouts(newOuts.length);
            for (int i = 0; i < newOuts.length; i++) {
                outs[i] = newOuts[i];
            }            
            _setOuts(newOuts);
        }
        else {
            outs = null;
        }
    }

    public void setOuts(DC_PipeOutStream_t newOuts, int index) throws ArrayIndexOutOfBoundsException {
        if (outs == null) {
            outs = new DC_PipeOutStream_t[index + 1];
        }
        else if (index < 0 || index > getNouts()) {
            throw new ArrayIndexOutOfBoundsException("in arg_t.setOuts(DC_PipeOutStream_t, index) index must be at least 0 and less than " + getNouts());
        }

	outs[index] = newOuts;
        _setOuts(newOuts, index);
    }
    
    public String getSbFilterName() {
        return _getSbFilterName();
    }
    
    public void setSbFilterName(String newSbFilterName) {
        _setSbFilterName(newSbFilterName);
    }
    
    public DC_Work_t getPWork() {
        _getPWork();

        return pWork;
    }
    
    public void setPWork(DC_Work_t newPWork) {
        if (newPWork != null) {
            pWork = newPWork;
            _setPWork(pWork);
        }
        else {
	   pWork = null;
        }
    }
    //SK: END ADDED ACCESS METHODS
    
    //CONSTRUCTED IN C++
    private void arg_t() {
        _initialize();
    }
    
    //~arg_t(void);
    protected void finalize() {
        _delete();
    }
    
    // rtn index to ins[], or -1=not found
    public int insIndex(String sbName) {
        return _insIndex(sbName);
    }
    
    // rtn index to outs[], or -1=not found
    public int outsIndex(String sbName) {
        return _outsIndex(sbName);
    }
    
    // null=not found
    public DC_PipeInStream_t insLookup(String sbName) {
        return _insLookup(sbName);
    }
    
    // null=not found
    public DC_PipeOutStream_t outsLookup(String sbName) {
        return _outsLookup(sbName);
    }
    
    // block until a buffer available from any input stream.  If all are
    // EOW or EOS, return null.
    //
    // Optional: rgStreamSet is an array of bool (one per ins).  If
    // set false, that ins will be ignored when looking for buffers.
    //java doesn't allow default values so overloaded function
    public DC_Buffer_t insReadAny() {
        return insReadAny(null, null);
    }
    
    //how to mimic behavior of int *piFound and boolean *rgStreamSet in java???
    public DC_Buffer_t insReadAny(DC_ObjectWrapper piFound) {
        return insReadAny(piFound, null);
    }
    
    //how to mimic behavior of int *piFound and boolean *rgStreamSet in java???
    public DC_Buffer_t insReadAny(DC_ObjectWrapper piFound, boolean[] rgStreamSet) {
        return _insReadAny(piFound, rgStreamSet);
    }
    
    // return: number of ins[] that already hit EOW
    public int insNumEOW() {
        return _insNumEOW();
    }
    
    // return: true=if all ins[] are at EOW
    public boolean insAllEOW() {
        return _insAllEOW();
    }
    
    // close all outgoing streams, wait for all input streams to see EOS
    //java doesn't allow default values so overloaded function
    public int CloseOutputWaitInput(int wWorkNum) {
        return CloseOutputWaitInput(wWorkNum, false);
    }
    
    public int CloseOutputWaitInput(int wWorkNum, boolean fEndOfWork) {
        return _closeOutputWaitInput(wWorkNum, fEndOfWork);
    }
    
    
    //PRIVATE NATIVE FOUNDATION HERE
    private native int _getNins();
    private native void _setNins(int newNins);
    private DC_PipeInStream_t[] ins = null;
    private native void _getIns();
    private native void _getIns(int index);
    private native void _setIns(DC_PipeInStream_t[] newIns);
    private native void _setIns(DC_PipeInStream_t newIns, int index);
    
    private native int _getNouts();
    private native void _setNouts(int newNouts);
    private DC_PipeOutStream_t[] outs = null;
    private native void _getOuts();
    private native void _getOuts(int index);
    private native void _setOuts(DC_PipeOutStream_t[] newOuts);
    private native void _setOuts(DC_PipeOutStream_t newOuts, int index);
    
    private native String _getSbFilterName();
    private native void _setSbFilterName(String newSbFilterName);
    private DC_Work_t pWork = null;
    private native void _setPWork(DC_Work_t newPWork);
    private native void _getPWork();
    
    private native void _initialize();
    private native void _delete();
    
    private native int _insIndex(String sbName);
    private native int _outsIndex(String sbName);
    private native DC_PipeInStream_t _insLookup(String sbName);
    private native DC_PipeOutStream_t _outsLookup(String sbName);
    private native DC_Buffer_t _insReadAny(DC_ObjectWrapper piFound, boolean[] rgStreamSet);
    private native int _insNumEOW();
    private native boolean _insAllEOW();
    private native int _closeOutputWaitInput(int wWorkNum, boolean fEndOfWork);
}
