package dc.jfilters;

public class initarg_t {
    //SK: REMOVED FRIEND DECLARATION (NO FRIENDS IN JAVA)
    //friend class DC_RemoteFilterCopy;
    
    //SK: REPLACED INSTANCE VARIABLES WITH ACCESS FUNCTIONS
    //public int argc;
    //public String[] argv; //was char ** in c++ needs setItems(whole array), setItems(index), getItems(entire array), getItems(index)
    //public String sbFilterName;
    //public DC_Work_t pwork;
    
    public int getArgc() {
        return _getArgc();
    }
    
    public String[] getArgv() {
        return _getArgv();
    }
    
    public String getArgv(int index) throws ArrayIndexOutOfBoundsException {
        if (index < 0 || index > getArgc()) {
            throw new ArrayIndexOutOfBoundsException("in initarg_t.getArgv(int) index must be at least 0 and less than " + getArgc());
        }
        return _getArgv(index);
    }
    
    public void setArgv(String[] newArgv) {
	_setArgc(newArgv.length);
        _setArgv(newArgv);
    }
    
    public void setArgv(String newArgv, int index) throws ArrayIndexOutOfBoundsException {
        if (index < 0 || index > getArgc()) {
            throw new ArrayIndexOutOfBoundsException("in initarg_t.setArgv(String, int) index must be at least 0 and less than " + getArgc());
        }        
        _setArgv(newArgv, index);
    }
    
    public String getSbFilterName() {
        return _getSbFilterName();
    }
    
    public void setSbFilterName(String newSbFilterName) {
        _setSbFilterName(newSbFilterName);
    }
    
    public DC_Work_t getPWork() {
        _getPWork();
        
        return pWork;
    }
    
    public void setPWork(DC_Work_t newPWork) {
        if (newPWork != null) {
            pWork = newPWork;
            _setPWork(pWork);
        }
        else {
            pWork = null;
        }
    }
    //SK: END ADDED ACCESS METHODS
    
    //CONSTRUCTED IN C++
    private void initarg_t() {
        _initialize();
    }
    
    //~initarg_t(void);
    protected void finalize() {
        _delete();
    }
    
    // on the current local host
    public int maxCopySets() {
        return _maxCopySets();
    }
    
    public int rankCopySets() {
        return _rankCopySets();
    }
    
    // in total for this instance
    public int maxCopies() {
        return _maxCopies();
    }
    
    public int rankCopies() {
        return _rankCopies();
    }
    
    
    //PRIVATE NATIVE FOUNDATION HERE
    private native int _getArgc();
    private native void _setArgc(int newArgc);
    private native String[] _getArgv();
    private native String _getArgv(int index);
    private native void _setArgv(String[] newArgv);
    private native void _setArgv(String newArgv, int index);
    private native String _getSbFilterName();
    private native void _setSbFilterName(String newSbFilterName);
    private DC_Work_t pWork = null;
    private native void _getPWork();
    private native void _setPWork(DC_Work_t newPWork);    
    
    private native void _initialize();
    private native void _delete();
    
    private native int _maxCopySets();
    private native int _rankCopySets();
    private native int _maxCopies();
    private native int _rankCopies();
}
