#if !defined(H_DC_CTOJAVA_FILTER)
#define H_DC_CTOJAVA_FILTER

#include <jni.h>
#include "reg/NativeReg.h"
#include "dc_filterservice.h"

class DC_CToJava_Filter_t : public DC_Filter_Base_t {
public:
   ~DC_CToJava_Filter_t();
   
   // user-defined interface methods
   virtual DC_RTN_t init(initarg_t &arg);
   virtual DC_RTN_t process(arg_t &arg) ;
   virtual DC_RTN_t finalize(void);

   static DC_Filter_Base_t *filter_factory(const char *sbFilterName);
private:
   //constructor is private because filter_factory will construct this class
   DC_CToJava_Filter_t(jobject newJavaFilter);
   jobject javaFilter;
};

#endif // !defined(H_DC_CTOJAVA_FILTER)
