#if !defined(H_DC_REGISTER_METHODS)
#define H_DC_REGISTER_METHODS

#include "reg/NativeReg.h"
#include "lib/dc_mutex.h"

class DC_RegisterMethods {
public:
   static void registerMethods();

private:
   static bool alreadyRegistered;
   static DC_Mutex lock;
   DC_RegisterMethods();

   static void registerArgTMethods(NativeReg *reg);
   static void registerBufferTMethods(NativeReg *reg);
   static void registerFilterBaseMethods(NativeReg *reg);
   static void registerPipeInStreamMethods(NativeReg *reg);
   static void registerPipeOutStreamMethods(NativeReg *reg);
   static void registerWorkMethods(NativeReg *reg);
   static void registerInitArgMethods(NativeReg *reg);
};
#endif //#!defined(H_DC_REGISTER_METHODS)
