// -*- c++ -*-
// ****************************************************************************
//  Name: packet-tags.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 08/19/1999 : mdb - Created.
//  Desc: 
// ****************************************************************************

#if !defined(H_DC_PACKET_TAGS)
#define H_DC_PACKET_TAGS


// Please make sure these are unique!

#define TAG_DIRD_ERROR				0
#define TAG_DIRD_OK				1
#define TAG_DIRD_PING				2
#define TAG_DIRD_ADD				3
#define TAG_DIRD_REMOVE				4
#define TAG_DIRD_QUERY				5
#define TAG_DIRD_SHUTDOWN			6

#define TAG_APPD_ERROR				10
#define TAG_APPD_OK				11
#define TAG_APPD_PING				12
#define TAG_APPD_EXEC				13
#define TAG_APPD_DONE				14
#define TAG_APPD_SHUTDOWN			15
#define TAG_APPD_FTP			        16
#define TAG_APPD_PSTACK			        17

#define TAG_FILTERSERVICE_CONSOLEOUT		27

#define TAG_FILTERSERVICE_HELLO			40
#define TAG_FILTERSERVICE_HELLO_ACK		41
#define TAG_FILTERSERVICE_STARTINSTANCE		42
#define TAG_FILTERSERVICE_STARTINSTANCE_ACK	43
#define TAG_FILTERSERVICE_STREAMCONNECT		44
#define TAG_FILTERSERVICE_STREAMCONNECT_ACK	45
#define TAG_FILTERSERVICE_APPENDWORK		46
#define TAG_FILTERSERVICE_APPENDWORK_ACK	47
#define TAG_FILTERSERVICE_APPENDWORK_DONE	48
#define TAG_FILTERSERVICE_DATA			49
#define TAG_FILTERSERVICE_DATA_ACK		50
#define TAG_FILTERSERVICE_EOW			51
#define TAG_FILTERSERVICE_EOS			52
#define TAG_FILTERSERVICE_STOPINSTANCE		53
#define TAG_FILTERSERVICE_READERCMDQ		54
#define TAG_FILTERSERVICE_READEREXIT		55
#define TAG_FILTERSERVICE_FILTEREXIT		56
#define TAG_FILTERSERVICE_INSTANCEEXIT		57
#define TAG_FILTERSERVICE_APPENDWORK_CANCEL     58

#define TAG_BOOTUTIL_INITACK                    100


#endif /* H_DC_PACKET_TAGS */
// ****************************************************************************
