// -*- c++ -*-
// ****************************************************************************
//  Name: thread-filter.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 04/08/2000 : mdb - Created.
//  Desc: Filter execution thread and supporting functions.
// ****************************************************************************

#if !defined(H_DC_THREAD_FILTER)
#define H_DC_THREAD_FILTER

/// arg passed to new threads to determine filter context
typedef struct thread_filter_arg_s {
  DC_FilterService_t    *pDC;
  DC_RemoteProcessState *pRemote; // need to get around visibility of pRemote
  int        *pargc;
  char     ***pargv;
} thread_filter_arg_t;

#endif /* H_DC_THREAD_FILTER */
// ****************************************************************************
