/*
 * DC_Filter_GetInput.java
 *
 * Created on August 20, 2001, 11:53 AM
 */
/**
 *
 * @author  sergek
 * @version 
 */

import dc.jfilters.*;

public class DC_Filter_GetInput extends DC_Filter_Base_t {
    public DC_Filter_GetInput() {
	super();
    }

    // user-defined interface methods
    public int start_work(initarg_t arg) {
        System.out.println(arg.getSbFilterName() + ": Starting Work");

	return DC_RTN_t.DC_RTN_OK;
    }
    
    public int process(arg_t arg) {
	System.out.println("Starting sleep");
	try {
	   Thread.sleep(30000);
  	} catch (InterruptedException e) {}

	System.out.println("Resuming");
	
	for (int i = 0; i < 5; i++) {
	   long startTime = System.currentTimeMillis();
	   DC_Buffer_t y = arg.getIns(0).read();
	   long result = System.currentTimeMillis() - startTime;
	   System.out.println("Buffer " + i + " of length " + y.getSize() + " read in " + result);
	}

	arg.getIns(0).close();
	//return arg.getIns(0).isEndOfWork() ? 
	//DC_RTN_t.DC_RTN_EndOfWork :
	//DC_RTN_t.DC_RTN_EndOfFilter;
	return DC_RTN_t.DC_RTN_OK;
    }

    public int finish_work() {
        System.out.println("Finish Work");
   	
	return DC_RTN_t.DC_RTN_OK; 
   }
}
