// -*- c++ -*-
// ****************************************************************************
//  Name: appd-client.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 09/12/1999 : mdb - Created.
//  Desc: 
// ****************************************************************************

#if !defined(H_APPD_CLIENT)
#define H_APPD_CLIENT

#ifdef _WIN32
#include "win32.h"
#endif


#include "appd.h"
#include "lib/dc_file.h"
#include "lib/dc_memory.h"

//
//  Client access routines
//

int Appd_Find(char *sbAppdHost, bool fWait=false);
int Appd_Ping(char *sbAppdHost, int wAppdPort);
int Appd_Shutdown(char *sbAppdHost, int wAppdPort);
int Appd_ShutdownAll(void);
int Appd_Pstack(char *sbAppdHost, int wAppdPort);
int Appd_Ftp(char *sbAppdHost, int wAppdPort,
	     File &f, unsigned int wChecksum, MemoryBuf &mb);


#endif /* H_APPD_CLIENT */
// ****************************************************************************
