// ****************************************************************************
//  Name: dc_policy.cpp
//  Athr: Michael D. Beynon (mdb)
//  Date: 07/27/2001 : mdb - Created.
//  Desc: 
// ****************************************************************************
#include <assert.h>

#include <iostream>
using namespace std;

#include "dc_policy.h"

const char *DC_StreamWritePolicy_tostr(DC_StreamWritePolicy_t ePolicy) {
  switch (ePolicy) {
  case DC_StreamWritePolicy_RR:
    return "RR";
  case DC_StreamWritePolicy_WRR:
    return "WRR";
  case DC_StreamWritePolicy_DD:
    return "DD";
  case DC_StreamWritePolicy_UD:
    return "UD";
  }
  cout << "DC_StreamWritePolicy_str(): Unknown stream write policy value "
       << static_cast(int,ePolicy) << endl;
  cout.flush();
  assert(0);
  return NULL;  // never executed
}

DC_StreamWritePolicy_t DC_StreamWritePolicy_toenum(char *sbPolicy) {
  if (StrCmp(sbPolicy, "RR", false) == 0) {
    return DC_StreamWritePolicy_RR;
  } else if (StrCmp(sbPolicy, "WRR", false) == 0) {
    return DC_StreamWritePolicy_WRR;
  } else if (StrCmp(sbPolicy, "DD", false) == 0) {
    return DC_StreamWritePolicy_DD;
  } else if (StrCmp(sbPolicy, "UD", false) == 0) {
    return DC_StreamWritePolicy_UD;
  }
  cout << "DC_StreamWritePolicy_int(): Unknown stream write policy \""
       << sbPolicy << '\"' << endl;
  cout.flush();
  assert(0);
  return DC_StreamWritePolicy_RR;  // never executed
}


// ****************************************************************************
