// -*- c++ -*-
// ****************************************************************************
//  Name: dc_types.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 09/16/1999 : mdb - Created.
//  Desc: 
// ****************************************************************************
/** @file dc_types.h */

#if !defined(H_TYPES)
#define H_TYPES

/// Types.
class Types {
public:
  // size specific
  typedef unsigned char  uint1;  // One byte unsigned integer
  typedef signed char    int1;   // One byte signed integer
  typedef unsigned short uint2;  // Two byte unsigned integer
  typedef signed short   int2;   // Two byte signed integer
  typedef unsigned int   uint4;  // Four byte unsigned integer
  typedef signed int     int4;   // Four byte signed integer

  // not size specific
  typedef unsigned char  uchar;
  typedef unsigned int   uint;

  static const unsigned int uintMax;  // defined in types.cpp
};


#endif /* H_TYPES */
// ****************************************************************************
