// -*- c++ -*-
// ****************************************************************************
//  Name: util.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 08/11/2000 : mdb - Created.
//  Desc: DataCutter Filter Service user library.
// ****************************************************************************

#if !defined(H_DC_UTIL)
#define H_DC_UTIL

#include "lib/dc_standard.h"
#include "lib/dc_configinfo.h"

extern char *FindParm(ConfigInfo &cfg,
		      const char *sbSection, const char *sbName,
		      bool fExitNotFound=true);
extern int FindParmIntDefault(ConfigInfo &cfg,
			      const char *sbSection, const char *sbName,
			      int wDefault);
extern bool FindParmBoolDefault(ConfigInfo &cfg,
				const char *sbSection, const char *sbName,
				bool fDefault);

extern int DC_EncodeInt(int w1, int w2);
extern void DC_DecodeInt(int wEncoded_in, int *pw1, int *pw2);


#endif /* H_DC_UTIL */
// ****************************************************************************
